#include <bits/stdc++.h>

using namespace std;

int niz[200000],a[200000],b[200000],unapred[200000],unazad[200000];

int main()
{
    int pomocna=2;
    int n,q;
    cin>>n;
    //int matrica[n][n];
    for(int i=0;i<n;i++){
        cin>>niz[i];
    }
    niz[n]=0;
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>a[i]>>b[i];
    }
    for(int i=0;i<n;i++){
        if(niz[i]>pomocna){
            pomocna = niz[i];
            break;
        }
    }
    unapred[0]=0;
    for(int i=1;i<n;i++){
        if(niz[i]<niz[i-1])unapred[i]=unapred[i-1]+1;
        else{
          unapred[i]=unapred[i-1];
        }
    }
    unazad[n-1]=0;
    for(int i=n-2;i>=0;i--){
        if(niz[i]>niz[i+1])unazad[i]=unazad[i+1]+1;
        else{
            unazad[i]=unazad[i+1];
        }
    }

    if(pomocna==2){
        unapred[0]=0;
        int zaredom1=0,zaredom2=0;
        for(int i=1;i<n;i++){
            if(niz[i]==2){
                zaredom2++;
                if(niz[i+1]==1)zaredom1=0;
                unapred[i]=unapred[i-1];
            }
            else if(niz[i]==1){
                zaredom1++;
                if(zaredom2>=zaredom1)unapred[i]=unapred[i-1]+1;
                else{
                    unapred[i]=unapred[i-1];
                }
                if(niz[i+1]==2)zaredom2=0;
            }
        }
    }

    /*for(int i=0;i<n;i++){
        cout<<unapred[i]<<" ";
    }
    cout<<endl;
    for(int i=0;i<n;i++){
        cout<<unazad[i]<<" ";
    }*/

    for(int i=0;i<q;i++){
        if(unapred[b[i]-1]-unapred[a[i]-1]>1)cout<<"NE \n";
        else{
            cout<<"DA \n";
        }
    }
    return 0;
}